#!/bin/env python

"""channel.py: Contains the channel class if sexiibot"""

__author__ = "raspbeguy"
__copyright__ = "Copyright 2016, raspbeguy"
__credits__ = ["raspbeguy"]
__license__ = "WTFPL"
__version__ = "0.1.1"
__maintainer__ = "raspbeguy"
__email__ = "raspbeguy@hashtagueule.fr"
__status__ = "Devlopment"

import time
import threading
import os
import shutil
#from core import Sexiibot

class Channel(object):
    """Channel class"""

    def __init__(self, name, bot, extensions=None, connected=False):
        self.__name    = name
        self.__bot     = bot
        self.__in      = None
        self.__out     = None
        self.__exts    = extensions
        self.__mode    = None
        self.__alive   = True
        self.__thread  = None
        self.__connect = connected
                        
    def join(self):
        if not os.path.exists(self.__bot.getIrcPath() + self.__name):
            os.makedirs(self.__bot.getIrcPath() + self.__name)
        open(self.__bot.getIrcPath() + "%s/out" % self.__name, 'a').close()
        self.__out = open(self.__bot.getIrcPath() + "%s/out" % self.__name, 'r')
        #self.__out.seek(0,2)
        self.__thread = threading.Thread(target=self.watch)
        self.__thread.start()
        while not self.__connect:
            self.__bot.sendJoin(self.__name)
            time.sleep(1)
        #TODO: add something to wait the FIFO to be ready
        time.sleep(1)
        self.__in = open(self.__bot.getIrcPath() + "%s/in" % self.__name, 'w', 1)
        

    def getName(self):
        return self.__name
   
    def message(self, msg):
        while self.__in == None:
            time.sleep(0.1)
        print("%s <-- %s" % (self.__name, msg))
        self.__in.write("%s\n" % msg)

    def action(self, action):
        self.message("/j %s" % action)

    def leave(self, msg="sexiibot, the bot you're dreaming about"):
        self.message("/l %s" % msg)
        self.__alive = False
        self.__connect = False
        self.__thread.join()
        self.__in.close()
        self.__out.close()
        shutil.rmtree(self.__bot.getIrcPath() + self.__name)

    def watch(self):
        while self.__alive:
            line = self.__out.readline().rstrip()
            if line:
                if not self.__connect:
                    self.__connect = True
                else:
                    message = line.split(' ',3)
                    self.treat(message)
            time.sleep(0.1)

    def treat(self, content): # bon là, clairement, c'est pas sa forme définitive, c'est qu'un POC
        if not content[2][1:-1] == self.__bot.getNick():
            print("%s --> %s" % (self.__name, content))
            if content[3] and self.__bot.getNick() in content[3]:
                self.message("%s, je suis flattée que l'on s'adresse à moi, malheureusement je suis sexiibot." % content[2][1:-1])

    def __del__(self):
        self.__alive = False
        self.__thread.join()
